﻿using System.Collections.Generic;

namespace NumericFunctions
{
    class FibbGenerator : INumberSequence
    {
        public string Name { get { return "fibb"; } }

        public IEnumerable<double> Numbers
        {
            get
            {
                yield return 1;
                yield return 1;

                long prev = 1;
                long curr = 1;

                while (true)
                {
                    long next = curr + prev;
                    prev = curr;
                    curr = next;
                    yield return next;
                }
            }
        }
    }
}