﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace NumericFunctions
{
    class NumericViewModel : INotifyPropertyChanged
    {
        public INumberSequence Sequence { get; set; }

        private int _count;
        public int Count
        {
            get { return _count; }
            set
            {
                _count = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Results"));
                }
            }
        }


        public IEnumerable<string> Results
        {
            get
            {
                int n = 1;

                foreach (double result in Sequence.Numbers)
                {
                    yield return String.Format("{0}({1}) = {2}", Sequence.Name, n, result);
                    ++n;
                    if (n > Count) yield break;
                }
            }

        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
