﻿using System.Collections.Generic;
using System.ComponentModel;

namespace NumericFunctions
{
    class NumericViewModel : INotifyPropertyChanged
    {
        public INumberSequence Sequence { get; set; }

        private int _count;
        public int Count
        {
            get { return _count; }
            set
            {
                _count = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Results"));
                }
            }
        }


        public IEnumerable<NumericResultViewModel> Results
        {
            get
            {
                int n = 1;

                foreach (double result in Sequence.Numbers)
                {
                    yield return 
                        new NumericResultViewModel
                        {
                            Argument = n,
                            Result = result,
                            FunctionName = Sequence.Name
                        };

                    ++n;
                    if (n > Count) yield break;
                }
            }

        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
